commit dcdeb142434c6a7cceab62640fd8f78f53c16d5b
Author: freddy77 <freddy77>
Date:   Fri Jun 12 08:53:49 2009 +0000

    improve variant support if --enable-developing

diff --git a/ChangeLog b/ChangeLog
index e973916..99326f8 100644
--- a/ChangeLog
+++ b/ChangeLog
@@ -1,3 +1,9 @@
+Fri Jun 12 10:53:39 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
+	* include/tds.h src/odbc/convert_tds2sql.c:
+	* src/odbc/unittests/data.c src/tds/convert.c src/tds/tds_checks.c:
+	* src/tds/token.c:
+	- improve variant support if --enable-developing
+
 Wed Jun 10 20:54:07 CEST 2009    Frediano Ziglio <freddy77_A_gmail_D_com>
 	* src/odbc/convert_tds2sql.c src/odbc/odbc.c src/odbc/odbc_util.c:
 	- move blob check to odbc_tds2sql
@@ -1642,4 +1648,4 @@ Wed Jan  9 19:54:43 EST 2008	JK Lowden <jklowden@freetds.org>
 	* ChangeLog  truncated because of release
 	* ChangeLog-0.82 added because of release
 	
-$Id: ChangeLog,v 1.2812 2009/06/10 18:54:38 freddy77 Exp $
+$Id: ChangeLog,v 1.2813 2009/06/12 08:53:49 freddy77 Exp $
diff --git a/include/tds.h b/include/tds.h
index 04dc446..2bfe1cd 100644
--- a/include/tds.h
+++ b/include/tds.h
@@ -20,7 +20,7 @@
 #ifndef _tds_h_
 #define _tds_h_
 
-/* $Id: tds.h,v 1.314 2009/05/28 16:23:31 freddy77 Exp $ */
+/* $Id: tds.h,v 1.315 2009/06/12 08:53:49 freddy77 Exp $ */
 
 #include <stdarg.h>
 #include <stdio.h>
@@ -917,6 +917,18 @@ typedef struct tds_blob
 	TDS_CHAR timestamp[8];
 } TDSBLOB;
 
+/**
+ * Store variant informations
+ */
+typedef struct tds_variant
+{
+	TDS_CHAR *data;
+	TDS_INT size;
+	TDS_INT data_len;
+	TDS_UCHAR type;
+	TDS_UCHAR collation[5];
+} TDSVARIANT;
+
 /** 
  * TDS 8.0 collation informations.
  */
diff --git a/src/odbc/convert_tds2sql.c b/src/odbc/convert_tds2sql.c
index fb8b928..750d3b5 100644
--- a/src/odbc/convert_tds2sql.c
+++ b/src/odbc/convert_tds2sql.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.63 2009/06/10 18:54:38 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert_tds2sql.c,v 1.64 2009/06/12 08:53:49 freddy77 Exp $");
 
 #define TDS_ISSPACE(c) isspace((unsigned char) (c))
 
@@ -154,7 +154,7 @@ odbc_tds2sql(TDS_STMT * stmt, TDSCOLUMN *curcol, int srctype, TDS_CHAR * src, TD
 	assert(desttype != SQL_C_DEFAULT);
 
 	if (curcol) {
-		if (is_blob_col(curcol))
+		if (is_blob_col(curcol) && curcol->column_type != SYBVARIANT)
 			src = ((TDSBLOB *) src)->textvalue;
 		if (is_variable_type(curcol->column_type)) {
 			src += curcol->column_text_sqlgetdatapos;
diff --git a/src/odbc/unittests/data.c b/src/odbc/unittests/data.c
index 2f1a59c..39ea5eb 100644
--- a/src/odbc/unittests/data.c
+++ b/src/odbc/unittests/data.c
@@ -13,7 +13,7 @@
  * Also we have to check normal char and wide char
  */
 
-static char software_version[] = "$Id: data.c,v 1.27 2009/05/28 16:17:49 freddy77 Exp $";
+static char software_version[] = "$Id: data.c,v 1.28 2009/06/12 08:53:49 freddy77 Exp $";
 static void *no_unused_var_warn[] = { software_version, no_unused_var_warn };
 
 static int result = 0;
@@ -35,6 +35,8 @@ Test(const char *type, const char *value_to_convert, SQLSMALLINT out_c_type, con
 	sprintf(sbuf, "SELECT CONVERT(%s, '%s') AS data", type, value_to_convert);
 	if (strncmp(value_to_convert, "0x", 2) == 0)
 		sprintf(sbuf, "SELECT CONVERT(%s, %s) COLLATE Latin1_General_CI_AS AS data", type, value_to_convert);
+	else if (strcmp(type, "SQL_VARIANT") == 0)
+		sprintf(sbuf, "SELECT CONVERT(SQL_VARIANT, %s) AS data", value_to_convert);
 	Command(sbuf);
 	SQLBindCol(Statement, 1, out_c_type, out_buf, sizeof(out_buf), &out_len);
 	CHKFetch("S");
@@ -178,6 +180,16 @@ main(int argc, char *argv[])
 	Test("DATETIME", "2006-06-09 11:22:44", SQL_C_WCHAR, "23 2006-06-09 11:22:44.000");
 	Test("SMALLDATETIME", "2006-06-12 22:37:21", SQL_C_WCHAR, "19 2006-06-12 22:37:00");
 
+#ifdef ENABLE_DEVELOPING
+	if (db_is_microsoft() && db_version_int() >= 0x08000000u) {
+		Test("SQL_VARIANT", "CAST('123' AS INT)", SQL_C_CHAR, "3 123");
+		Test("SQL_VARIANT", "CAST('ciao' AS VARCHAR(10))", SQL_C_CHAR, "4 ciao");
+		Test("SQL_VARIANT", "CAST('321' AS VARBINARY(10))", SQL_C_CHAR, "6 333231");
+		Test("SQL_VARIANT", "CAST('-123.4' AS FLOAT)", SQL_C_CHAR, "6 -123.4");
+		Test("SQL_VARIANT", "CAST('-123.4' AS NUMERIC(10,2))", SQL_C_CHAR, "6 -123.4");
+	}
+#endif
+
 	if (db_is_microsoft() && db_version_int() >= 0x09000000u) {
 		Test("VARCHAR(MAX)", "goodbye!", SQL_C_CHAR, "8 goodbye!");
 		Test("NVARCHAR(MAX)", "Micio mao", SQL_C_CHAR, "9 Micio mao");
diff --git a/src/tds/convert.c b/src/tds/convert.c
index 6ebd544..b665b31 100644
--- a/src/tds/convert.c
+++ b/src/tds/convert.c
@@ -64,7 +64,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: convert.c,v 1.191 2009/06/09 06:50:12 freddy77 Exp $");
+TDS_RCSID(var, "$Id: convert.c,v 1.192 2009/06/12 08:53:49 freddy77 Exp $");
 
 typedef unsigned short utf16_t;
 
@@ -1620,6 +1620,13 @@ tds_convert(const TDSCONTEXT * tds_ctx, int srctype, const TDS_CHAR * src, TDS_U
 
 	assert(srclen >= 0 && srclen <= 2147483647u);
 
+	if (srctype == SYBVARIANT) {
+		TDSVARIANT *v = (TDSVARIANT*) src;
+		srctype = v->type;
+		src = v->data;
+		srclen = v->data_len;
+	}
+
 	switch (srctype) {
 	case CASE_ALL_CHAR:
 		length = tds_convert_char(srctype, src, srclen, desttype, cr);
diff --git a/src/tds/tds_checks.c b/src/tds/tds_checks.c
index 81cba27..50f60de 100644
--- a/src/tds/tds_checks.c
+++ b/src/tds/tds_checks.c
@@ -44,7 +44,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: tds_checks.c,v 1.22 2009/05/28 16:23:32 freddy77 Exp $");
+TDS_RCSID(var, "$Id: tds_checks.c,v 1.23 2009/06/12 08:53:49 freddy77 Exp $");
 
 #if ENABLE_EXTRA_CHECKS
 
@@ -201,6 +201,8 @@ tds_check_column_extra(const TDSCOLUMN * column)
 	} else if (column->column_varint_size == 8) {
 		assert(column->on_server.column_type == XSYBVARCHAR || column->on_server.column_type == XSYBVARBINARY || column->on_server.column_type == XSYBNVARCHAR);
 		varint_ok = 1;
+	} else if (column->column_type == SYBVARIANT) {
+		assert(column->column_varint_size == 4);
 	} else {
 		assert(column->column_varint_size < 3);
 	}
diff --git a/src/tds/token.c b/src/tds/token.c
index 6e74dc9..c545ef8 100644
--- a/src/tds/token.c
+++ b/src/tds/token.c
@@ -42,7 +42,7 @@
 #include <dmalloc.h>
 #endif
 
-TDS_RCSID(var, "$Id: token.c,v 1.361 2009/06/09 08:55:23 freddy77 Exp $");
+TDS_RCSID(var, "$Id: token.c,v 1.362 2009/06/12 08:53:49 freddy77 Exp $");
 
 #define USE_ICONV tds->use_iconv
 
@@ -1985,6 +1985,93 @@ tds9_get_varmax(TDSSOCKET * tds, TDSCOLUMN * curcol)
 }
 #endif
 
+static int
+tds7_get_variant(TDSSOCKET * tds, TDSCOLUMN * curcol)
+{
+#ifdef ENABLE_DEVELOPING
+	int colsize = tds_get_int(tds), varint;
+	TDS_UCHAR type, info_len;
+	TDSVARIANT *v;
+
+	/* NULL */
+	curcol->column_cur_size = -1;
+	if (colsize < 2) {
+		tds_get_n(tds, NULL, colsize);
+		return TDS_SUCCEED;
+	}
+
+	v = (TDSVARIANT*) curcol->column_data;
+	v->type = type = tds_get_byte(tds);
+	info_len = tds_get_byte(tds);
+	colsize -= 2;
+	if (info_len > colsize)
+		goto error_type;
+	if (is_collate_type(type)) {
+		if (sizeof(v->collation) > info_len)
+			goto error_type;
+		tds_get_n(tds, v->collation, sizeof(v->collation));
+		colsize -= sizeof(v->collation);
+		info_len -= sizeof(v->collation);
+	}
+	/* special case for numeric */
+	if (is_numeric_type(type)) {
+		TDS_NUMERIC *num;
+		if (info_len != 2)
+			goto error_type;
+		if (v->data)
+			TDS_ZERO_FREE(v->data);
+		v->data_len = sizeof(TDS_NUMERIC);
+		num = (TDS_NUMERIC*) calloc(1, sizeof(TDS_NUMERIC));
+		v->data = num;
+		num->precision = tds_get_byte(tds);
+		num->scale     = tds_get_byte(tds);
+		colsize -= 2;
+		/* FIXME check prec/scale, don't let server crash us */
+		if (colsize > sizeof(num->array))
+			goto error_type;
+		tds_get_n(tds, num->array, colsize);
+		if (IS_TDS7_PLUS(tds))
+			tds_swap_numeric(num);
+		return TDS_SUCCEED;
+	}
+	varint = tds_get_varint_size(tds, type);
+	if (varint != info_len)
+		goto error_type;
+	switch (varint) {
+	case 0:
+		v->size = tds_get_size_by_type(type);
+		break;
+	case 1:
+		v->size = tds_get_byte(tds);
+		break;
+	case 2:
+		v->size = tds_get_smallint(tds);
+		break;
+	default:
+		goto error_type;
+	}
+	colsize -= info_len;
+	curcol->column_cur_size = colsize;
+	if (v->data)
+		TDS_ZERO_FREE(v->data);
+	v->data_len = colsize;
+	if (colsize) {
+		v->data = (TDS_CHAR*) malloc(colsize);
+		tds_get_n(tds, v->data, colsize);
+	}
+	return TDS_SUCCEED;
+
+error_type:
+	tds_get_n(tds, NULL, colsize);
+	return TDS_FAIL;
+#else
+	int colsize = tds_get_int(tds);
+	tds_get_n(tds, NULL, colsize);
+	curcol->column_cur_size = -1;
+	return TDS_SUCCEED;
+#endif
+}
+
 /**
  * Read a data from wire
  * \param tds state information for the socket and the TDS protocol
@@ -2013,12 +2100,8 @@ tds_get_data(TDSSOCKET * tds, TDSCOLUMN * curcol)
 		 * len (int32), type (int8), 7 (int8), collation, column size (int16) -- [n]char, [n]varchar, binary, varbinary 
 		 * BLOBS (text/image) not supported
 		 */
-		if (curcol->column_type == SYBVARIANT) {
-			colsize = tds_get_int(tds);
-			tds_get_n(tds, NULL, colsize);
-			curcol->column_cur_size = -1;
-			return TDS_SUCCEED;
-		}
+		if (curcol->column_type == SYBVARIANT)
+			return tds7_get_variant(tds, curcol);
 		
 		/*
 		 * LONGBINARY

